<form method="post"
      action="{$before_path}/admin/addonmodules.php?module=puq_customization&extension=ticket_auto_reply&action=replies">
    <input type="text" name="replies_json_to_server" value="" hidden>
</form>
<div class="status-badge-orange clientssummarybox">
    <div class="detail">
        <p><i class="fas fa-info"></i>
            <b> {$lang['Merge Fields']} </b><br> {$lang['In auto-reply you can enter merge field variables, which the system replaces with the user`s data when it sends the reply.']}
            <br>{$lang['The exact list of fields you have available in auto-reply message, appears directly below the message box with the field description and merge field code.']}
            <b><br>{$lang['Please, be attentive when selecting variables for each response, as specific variables are available for certain types of customers.']}
            </b>
        </p>
        <p>{$lang['Types of customers and lists of available variables']}:</p>
        <p><i class="fas fa-info"></i> <b>{$lang['1 Client type']}
                - </b> {$lang['Registered customer who has chosen the service they are referring to when submitting the inquiry.']}
            <br>{$lang['Variables available from the lists']}
            : "<b>Product/Service Related</b>", "<b>Client Related</b>" {$lang['and']} "<b>Other</b>"
        </p>
        <p><i class="fas fa-info"></i> <b> {$lang['2 Client type']}
                - </b> {$lang['Registered customer who has not chosen the service they are referring to when submitting the inquiry.']}
            <br>{$lang['Variables available from the lists']}
            : "<b>Client Related</b>" {$lang['and']} "<b>Other</b>"
        </p>
        <p><i class="fas fa-info"></i> <b> {$lang['3 Client type']}
                - </b> {$lang['Unregistered customer.']}<br>{$lang['Variables available from the lists']}: "<b>Other</b>"
        </p>
    </div>
</div>
<br>
<button onclick="sendJSON()" type="submit" class="btn btn-success"><i
            class="fa fa-pencil">&nbsp;</i><b>{$lang['Save']}</b></button>

<form name="departments">
    <div class="form-group" style="border-radius: 4px; padding: 5px;">
        <table class="datatable" style="width: 100%;">
            <tr class="header">
                <th style="width: 5%">{$lang['Enable Auto-Reply']}</th>
                <th style="width: 15%">{$lang['Department Name']}</th>


                <th style="width: 5%">{$lang['Overwrite Reply for 1 Client type']}</th>
                <th style="width: 15%">{$lang['Reply for 1 Client type']}</th>


                <th style="width: 5%">{$lang['Overwrite Reply for 2 Client type']}</th>
                <th style="width: 15%">{$lang['Reply for 2 Client type']}</th>


                <th style="width: 5%">{$lang['Overwrite Reply for 3 Client type']}</th>
                <th style="width: 15%">{$lang['Reply for 3 Client type']}</th>


                <th style="width: 15%">{$lang['Select Admin for Auto-Reply']}</th>
                <th style="width: 5%">{$lang['Number of minutes before the reply']}</th>
            </tr>
            {foreach $departments as $department}
                <tr>
                    <td style="text-align: center"><b><input type="checkbox"
                                                             name="{$department['id']}_enable_reply" {if $department['enable_reply']} checked {/if}></b>
                    </td>
                    <td style="text-align: center"><b>{$department['name']}</b><br>{$department['email']}</td>


                    <td style="text-align: center"><b><input type="checkbox"
                                                             name="{$department['id']}_allow_first" {if $department['allow_first']} checked {/if}></b>
                    </td>
                    <td style="text-align: center"><textarea class="form-control" rows="3" cols="40"
                                                             name="{$department['id']}_overwrite_first" {if !$department['allow_first']} disabled>{$config['default_reply']} {else}>{$department['reply_for_first']}{/if}</textarea>
                    </td>


                    <td style="text-align: center"><b><input type="checkbox"
                                                             name="{$department['id']}_allow_second" {if $department['allow_second']} checked {/if}></b>
                    </td>
                    <td style="text-align: center"><textarea class="form-control" rows="3" cols="40"
                                                             name="{$department['id']}_overwrite_second" {if !$department['allow_second']} disabled>{$config['default_reply']} {else}>{$department['reply_for_second']}{/if}</textarea>
                    </td>


                    <td style="text-align: center"><b><input type="checkbox"
                                                             name="{$department['id']}_allow_third" {if $department['allow_third']} checked {/if}></b>
                    </td>
                    <td style="text-align: center"><textarea class="form-control" rows="3" cols="40"
                                                             name="{$department['id']}_overwrite_third" {if !$department['allow_third']} disabled>{$config['default_reply']} {else}>{$department['reply_for_third']}{/if}</textarea>
                    </td>


                    <td style="text-align: center">
                        <select name="{$department['id']}_admin_username" class="form-control">
                            {foreach $department['admins'] as $admin}
                                <option value="{$admin['username']}"
                                        {if empty($department['admin_username']) and !empty($config['default_admin_username'])}
                                    {if $config['default_admin_username'] eq {$admin['username']}}selected {/if}
                                        {else}
                                    {if $department['admin_username'] eq {$admin['username']}}selected {/if}{/if}>
                                    {$admin['username']} - {$admin['firstname']} {$admin['lastname']} ({$admin['email']}
                                    ) - {$admin['role_name']}
                                </option>
                            {/foreach}
                        </select>
                    </td>
                    <td style="text-align: center; "><input type="number" name="{$department['id']}_minutes_before"
                                                            class="form-control" style="width: 100%"
                                                            value="{if empty($department['minutes_before']) and !empty($config['default_minutes_before'])}{$config['default_minutes_before']}{else}{$department['minutes_before']}{/if}">
                    </td>
                </tr>
            {/foreach}
        </table>
    </div>
</form>

{include file="$dir/extensions/TicketAutoReply/templates/list_of_variables.tpl"}

<hr>
{literal}
    <script>
        document.addEventListener('DOMContentLoaded', function () {
            const overwriteCheckboxesFirst = document.querySelectorAll('input[name$="_allow_first"]');
            const overwriteCheckboxesSecond = document.querySelectorAll('input[name$="_allow_second"]');
            const overwriteCheckboxesThird = document.querySelectorAll('input[name$="_allow_third"]');

            overwriteCheckboxesFirst.forEach(function (checkbox) {
                checkbox.addEventListener('change', function () {
                    const isAllowOverwrite = this.checked;
                    const descriptionField = this.closest('tr').querySelector('textarea[name$="_overwrite_first"]');
                    descriptionField.disabled = !isAllowOverwrite;
                });
            });
            overwriteCheckboxesSecond.forEach(function (checkbox) {
                checkbox.addEventListener('change', function () {
                    const isAllowOverwrite = this.checked;
                    const descriptionField = this.closest('tr').querySelector('textarea[name$="_overwrite_second"]');
                    descriptionField.disabled = !isAllowOverwrite;
                });
            });
            overwriteCheckboxesThird.forEach(function (checkbox) {
                checkbox.addEventListener('change', function () {
                    const isAllowOverwrite = this.checked;
                    const descriptionField = this.closest('tr').querySelector('textarea[name$="_overwrite_third"]');
                    descriptionField.disabled = !isAllowOverwrite;
                });
            });
        });
    </script>
    <script type="text/javascript">
        function sendJSON() {
            var originalJson = {};
            var formData = new FormData(document.forms.departments);

            formData.forEach(function (value, key) {
                originalJson[key] = value;
            });

            const newJson = {};

            // Проходим по всем ключам originalJson
            Object.keys(originalJson).forEach(key => {
                const parts = key.split('_'); // Разбиваем ключ по символу '_'
                const id = parts[0];
                const property = parts[1];

                if (property === 'overwrite' && parts[2] === 'first') {
                    if (!newJson[id]) {
                        newJson[id] = {};
                    }
                    // Добавляем описание, соответствующее продукту
                    newJson[id]['reply_for_first'] = originalJson[key];
                }

                if (property === 'allow' && parts[2] === 'first') {
                    if (!newJson[id]) {
                        newJson[id] = {};
                    }
                    // Добавляем описание, соответствующее продукту
                    newJson[id]['allow_first'] = originalJson[key];
                }


                if (property === 'overwrite' && parts[2] === 'second') {
                    if (!newJson[id]) {
                        newJson[id] = {};
                    }
                    // Добавляем описание, соответствующее продукту
                    newJson[id]['reply_for_second'] = originalJson[key];
                }

                if (property === 'allow' && parts[2] === 'second') {
                    if (!newJson[id]) {
                        newJson[id] = {};
                    }
                    // Добавляем описание, соответствующее продукту
                    newJson[id]['allow_second'] = originalJson[key];
                }


                if (property === 'overwrite' && parts[2] === 'third') {
                    if (!newJson[id]) {
                        newJson[id] = {};
                    }
                    // Добавляем описание, соответствующее продукту
                    newJson[id]['reply_for_third'] = originalJson[key];
                }

                if (property === 'allow' && parts[2] === 'third') {
                    if (!newJson[id]) {
                        newJson[id] = {};
                    }
                    // Добавляем описание, соответствующее продукту
                    newJson[id]['allow_third'] = originalJson[key];
                }


                if (property === 'enable' && parts[2] === 'reply') {
                    if (!newJson[id]) {
                        newJson[id] = {};
                    }
                    // Добавляем описание, соответствующее продукту
                    newJson[id]['enable_reply'] = originalJson[key];
                }

                if (property === 'admin' && parts[2] === 'username') {
                    if (!newJson[id]) {
                        newJson[id] = {};
                    }
                    // Добавляем описание, соответствующее продукту
                    newJson[id]['admin_username'] = originalJson[key];
                }
                if (property === 'minutes' && parts[2] === 'before') {
                    if (!newJson[id]) {
                        newJson[id] = {};
                    }
                    // Добавляем описание, соответствующее продукту
                    newJson[id]['minutes_before'] = originalJson[key];
                }
            });

            // Видаляємо ключі з порожніми значеннями
            Object.keys(newJson).forEach(key => {
                if (!newJson[key]['reply_for_first'] && !newJson[key]['allow_first'] && !newJson[key]['reply_for_second'] && !newJson[key]['allow_second'] && !newJson[key]['reply_for_third'] && !newJson[key]['allow_third'] && !newJson[key]['enable_reply'] && !newJson[key]['admin_username'] && !newJson[key]['minutes_before']) {
                    delete newJson[key];
                }
            });

            const jsonString = JSON.stringify(newJson);
            const hiddenField = document.querySelector('input[name="replies_json_to_server"]');
            hiddenField.value = jsonString;
            hiddenField.form.submit();
        }
    </script>
{/literal}