<form method="post" action="{$before_path}/admin/addonmodules.php?module=puq_customization&extension=overwrite_tax_rules&action=home_companies">

    <table class="form" width="100%" border="0" cellspacing="2" cellpadding="3">
        <tbody>

        <tr>
            <td class="fieldlabel" style="min-width:200px;">{$lang['Company name']}</td>
            <td class="fieldarea">
                <input type="hidden" name="id" value="{$company['id']}">
                <input type="text" name="name" value="{$company['name']}" class="form-control input-inline input-300" required>
            </td>
        </tr>

        <tr>
            <td class="fieldlabel" style="min-width:200px;"></td>
            <td class="fieldarea">
                <label class="checkbox-inline">
                    <input type="checkbox" name="default" value="1" {if $company['default']}checked{/if}>{$lang['Default']}
                </label>
            </td>
        </tr>

        <tr>
            <td class="fieldlabel">{$lang['Country']}</td>
            <td class="fieldarea">
                <select name="country_code" class="form-control select-inline">
                    {foreach $countries as $key => $value}
                        <option value="{$key}" {if $company['country_code'] eq $key}selected{/if}>{$key} - {$value['name']}</option>
                    {/foreach}
                </select>
            </td>
        </tr>

        <tr>
            <td class="fieldlabel" style="min-width:200px;">{$lang['Your Tax ID/VAT Number']}</td>
            <td class="fieldarea">
                <input type="text" name="tax_id" value="{$company['tax_id']}" class="form-control input-inline input-300">
            </td>
        </tr>

        <tr>
            <td class="fieldlabel" style="min-width:200px;">{$lang['Tax name']}</td>
            <td class="fieldarea">
                <input type="text" name="tax_name" value="{$company['tax_name']}" class="form-control input-inline input-300">
            </td>
        </tr>

        <tr>
            <td class="fieldlabel" style="min-width:200px;">{$lang['Tax rate']}</td>
            <td class="fieldarea">
                <div class="col-lg-2 col-sm-6">
                    <div class="input-group">
                        <input style="margin-top: 0;" type="number" name="tax_rate" class="form-control add-rule-field" placeholder="0.000" step=".001" value="{$company['tax_rate']}">
                        <div class="input-group-addon">%</div>
                    </div>
                    <small>{$lang['Supports up to 3 decimals']}</small>
                </div>
            </td>
        </tr>

        <tr>
            <td class="fieldlabel" style="min-width:200px;">{$lang['Numbering']}</td>
            <td class="fieldarea">

                <table class="form input-inline">
                    <tr>
                        <td class="fieldlabel">
                            <label class="checkbox-inline">
                                <input type="checkbox" name="proforma_invoice_numbering" value="1" {if $company['proforma_invoice_numbering']} checked {/if}>{$lang['Proforma invoice numbering']}
                            </label></td>
                        <td class="fieldarea">
                            <label for="proforma_invoice_numbering_format">{$lang['Proforma invoice numbering format']}</label>
                            <input type="text" name="proforma_invoice_numbering_format" value="{$company['proforma_invoice_numbering_format']}" class="form-control input-300">
                            <small>{$lang['Available Tags']}:
                                {literal}{YEAR} {MONTH} {DAY} {NUMBER}{/literal}
                            </small>
                        </td>
                    </tr>

                    <tr>
                        <td class="fieldlabel">
                            <label for="proforma_invoice_number">{$lang['Next proforma invoice number']}</label>
                            <input type="number" min="1" name="proforma_invoice_number" placeholder="1" value="{$company['proforma_invoice_number']}" class="form-control input-125">
                        </td>
                        <td class="fieldarea">
                            <label for="proforma_invoice_auto_reset_numbering">{$lang['Proforma invoice auto reset numbering']}</label>
                            <select name="proforma_invoice_auto_reset_numbering" class="form-control">
                                <option value="never" {if $company['proforma_invoice_auto_reset_numbering'] eq 'never'}selected{/if}>{$lang['Never']}</option>
                                <option value="monthly" {if $company['proforma_invoice_auto_reset_numbering'] eq 'monthly'}selected{/if}>{$lang['Monthly']}</option>
                                <option value="annually" {if $company['proforma_invoice_auto_reset_numbering'] eq 'annually'}selected{/if}>{$lang['Annually']}</option>
                            </select>
                        </td>
                    </tr>
                </table>

                <table class="form input-inline">
                    <tr>
                        <td class="fieldlabel">
                            <label class="checkbox-inline">
                                <input type="checkbox" name="invoice_numbering" value="1" {if $company['invoice_numbering']} checked {/if} >{$lang['Invoice numbering']}
                            </label></td>
                        <td class="fieldarea">
                            <label for="invoice_numbering_format">{$lang['Invoice numbering format']}</label>
                            <input type="text" name="invoice_numbering_format" value="{$company['invoice_numbering_format']}" class="form-control input-300">
                            <small>{$lang['Available Tags']}:
                                {literal}{YEAR} {MONTH} {DAY} {NUMBER}{/literal}
                            </small>
                        </td>
                    </tr>

                    <tr>
                        <td class="fieldlabel">
                            <label for="invoice_number">{$lang['Next invoice number']}</label>
                            <input type="number" min="1" name="invoice_number" placeholder="1" value="{$company['invoice_number']}" class="form-control input-125">
                        </td>
                        <td class="fieldarea">
                            <label for="invoice_auto_reset_numbering">{$lang['Invoice auto reset numbering']}</label>
                            <select name="invoice_auto_reset_numbering" class="form-control">
                                <option value="never" {if $company['invoice_auto_reset_numbering'] eq 'never'}selected{/if}>{$lang['Never']}</option>
                                <option value="monthly" {if $company['invoice_auto_reset_numbering'] eq 'monthly'}selected{/if}>{$lang['Monthly']}</option>
                                <option value="annually" {if $company['invoice_auto_reset_numbering'] eq 'annually'}selected{/if}>{$lang['Annually']}</option>
                            </select>
                        </td>
                    </tr>
                </table>

            </td>
        </tr>

        <tr>
            <td class="fieldlabel">{$lang['Pay to text']}</td>
            <td class="fieldarea">
                <textarea cols="50" rows="5" name="pay_to_text" class="form-control bottom-margin-5">{$company['pay_to_text']}</textarea>
                {$lang['This text is displayed on the invoice as the Pay To details']}
            </td>
        </tr>

        </tbody>
    </table>
    <div class="btn-container">
        <button type="submit" name="submit" value="edit_company" class="btn btn-primary">{$lang['Save Changes']}</button>
        <button type="submit" name="submit" value="delete_company" class="btn btn-danger" onclick="return confirm('{$lang['Are you sure you want to delete?']}')" >{$lang['Delete Company']}</button>
    </div>
</form>