<form method="post"
      action="{$before_path}/admin/addonmodules.php?module=puq_customization&extension=promo_code_api&action=promo_sets">
    <table class="form" width="100%" border="0" cellspacing="2" cellpadding="3">
        <tbody>
        <tr>
            <td class="fieldlabel" width="15%">{$lang['Set Name']}</td>
            <input type="hidden" name="id" value="{$promo_set['id']}">
            <td class="fieldarea"><input type="text" name="set_name" value="{$promo_set['name']}"
                                         class="form-control input-250 input-inline" required></td>
        </tr>
        <tr>
            <td class="fieldlabel" width="15%">{$lang['API Ip Address']}</td>
            <input type="hidden" name="api_key" value="{$promo_set['api_key']}">
            <td class="fieldarea"><input type="text" name="api_ip_address" value="{$promo_set['api_ip_address']}"
                                         class="form-control input-250 input-inline" required>
                <input type="text" name="url" value="{$before_path}/{$promo_set['url']}"
                       class="form-control input-700 input-inline" disabled></td>
        </tr>
        <tr>
            <td class="fieldlabel">{$lang['Promo Code Type']}</td>
            <td class="fieldarea"><select name="promo_code_type" class="form-control select-inline">
                    <option value="Percentage"
                            {if $promo_set['promo_code_type'] eq 'Percentage'}selected{/if}>{$lang['Percentage']}</option>
                    <option value="Fixed Amount"
                            {if $promo_set['promo_code_type'] eq 'Fixed Amount'}selected{/if}>{$lang['Fixed Amount']}</option>
                    <option value="Price Override"
                            {if $promo_set['promo_code_type'] eq 'Price Override'}selected{/if}>{$lang['Price Override']}</option>
                    <option value="Free Setup"
                            {if $promo_set['promo_code_type'] eq 'Free Setup'}selected{/if}>{$lang['Free Setup']}</option>
                </select></td>
        </tr>
        <tr>
            <td class="fieldlabel">{$lang['Recurring']}</td>
            <td class="fieldarea">
                <label class="checkbox-inline">
                    <input type="checkbox" name="recurring" value="on" {if $promo_set['recurring'] eq '1'}checked{/if}>
                    {$lang['Enable - Recur For']} </label>
                <input id="recurfor" type="text" name="recur_for" class="form-control input-50 input-inline"
                       value="{$promo_set['recur_for']}">
                {$lang['Times (0 = Unlimited)']}
            </td>
        </tr>
        <tr>
            <td class="fieldlabel">{$lang['Value']}</td>
            <td class="fieldarea"><input type="text" name="promo_value" placeholder="0.00"
                                         class="form-control input-150 input-inline"
                                         value="{$promo_set['promo_value']}"></td>
        </tr>
        <tr>
            <td class="fieldlabel">{$lang['Applies To']}</td>
            <td class="fieldarea">
                <select name="applies_to[]" size="8" class="form-control" multiple="">
                    {foreach $products_list as $product}
                        <option value="{$product['id']}"
                                {if in_array($product['id'], $promo_set['applies_to'])}selected{/if}>
                            {$product['group_name']} - {$product['product_name']}</option>
                    {/foreach}
                    {foreach $addons_list as $addon}
                        <option value="{$addon['id']}"
                                {if in_array($addon['id'], $promo_set['applies_to'])}selected{/if}>
                            Addon - {$addon['addon_name']}</option>
                    {/foreach}
                    {foreach $domains_list as $domain}
                        <option value="{$domain['id']}"
                                {if in_array($domain['id'], $promo_set['applies_to'])}selected{/if}>
                            Domain - {$domain['domain_extension']}</option>
                    {/foreach}
                </select></td>
        </tr>
        <tr>
            <td class="fieldlabel">{$lang['Requires']}</td>
            <td class="fieldarea">
                <select name="requires[]" size="8" class="form-control" multiple="">
                    {foreach $products_list as $product}
                        <option value="{$product['id']}"
                                {if in_array($product['id'], $promo_set['requires'])}selected{/if}>
                            {$product['group_name']} - {$product['product_name']}</option>
                    {/foreach}
                    {foreach $addons_list as $addon}
                        <option value="{$addon['id']}"
                                {if in_array($addon['id'], $promo_set['requires'])}selected{/if}>
                            Addon - {$addon['addon_name']}</option>
                    {/foreach}
                    {foreach $domains_list as $domain}
                        <option value="{$domain['id']}"
                                {if in_array($domain['id'], $promo_set['requires'])}selected{/if}>
                            Domain - {$domain['domain_extension']}</option>
                    {/foreach}
                </select><br><input type="checkbox" name="requires_existing"
                                    value="on"
                                    {if $promo_set['requires_existing'] eq '1'}checked{/if}> {$lang['Also allow existing products in account to qualify for promotion']}
            </td>
        </tr>
        <tr>
            <td class="fieldlabel">{$lang['Billing Cycles']}<br>({$lang['No selection = any']})</td>
            <td class="fieldarea">

                <b>{$lang['Products/Services']}</b><br>
                <label class="checkbox-inline"><input type="checkbox" name="cycles[]"
                                                      value="One Time"
                                                      {if in_array("One Time", $promo_set['cycles'])}checked{/if}>{$lang['One Time']}
                </label>
                <label class="checkbox-inline"><input type="checkbox" name="cycles[]" value="Monthly"
                                                      {if in_array("Monthly", $promo_set['cycles'])}checked{/if}>{$lang['Monthly']}
                </label>
                <label class="checkbox-inline"><input type="checkbox" name="cycles[]"
                                                      value="Quarterly"
                                                      {if in_array("Quarterly", $promo_set['cycles'])}checked{/if}>{$lang['Quarterly']}
                </label>
                <label class="checkbox-inline"><input type="checkbox" name="cycles[]"
                                                      value="Semi-Annually"
                                                      {if in_array("Semi-Annually", $promo_set['cycles'])}checked{/if}>{$lang['Semi-Annually']}
                </label>
                <label class="checkbox-inline"><input type="checkbox" name="cycles[]"
                                                      value="Annually"
                                                      {if in_array("Annually", $promo_set['cycles'])}checked{/if}>{$lang['Annually']}
                </label>
                <label class="checkbox-inline"><input type="checkbox" name="cycles[]"
                                                      value="Biennially"
                                                      {if in_array("Biennially", $promo_set['cycles'])}checked{/if}>{$lang['Biennially']}
                </label>
                <label class="checkbox-inline"><input type="checkbox" name="cycles[]"
                                                      value="Triennially"
                                                      {if in_array("Triennially", $promo_set['cycles'])}checked{/if}>{$lang['Triennially']}
                </label>
                <br>
                <b>{$lang['Domains']}</b><br>
                <label class="checkbox-inline"><input type="checkbox" name="cycles[]" value="1Years"
                                                      {if in_array("1Years", $promo_set['cycles'])}checked{/if}>
                    1 {$lang['Year']}
                </label>
                <label class="checkbox-inline"><input type="checkbox" name="cycles[]" value="2Years"
                                                      {if in_array("2Years", $promo_set['cycles'])}checked{/if}>
                    2 {$lang['Years']}
                </label>
                <label class="checkbox-inline"><input type="checkbox" name="cycles[]" value="3Years"
                                                      {if in_array("3Years", $promo_set['cycles'])}checked{/if}>
                    3 {$lang['Years']}
                </label>
                <label class="checkbox-inline"><input type="checkbox" name="cycles[]" value="4Years"
                                                      {if in_array("4Years", $promo_set['cycles'])}checked{/if}>
                    4 {$lang['Years']}
                </label>
                <label class="checkbox-inline"><input type="checkbox" name="cycles[]" value="5Years"
                                                      {if in_array("5Years", $promo_set['cycles'])}checked{/if}>
                    5 {$lang['Years']}
                </label>
                <label class="checkbox-inline"><input type="checkbox" name="cycles[]" value="6Years"
                                                      {if in_array("6Years", $promo_set['cycles'])}checked{/if}>
                    6 {$lang['Years']}
                </label>
                <label class="checkbox-inline"><input type="checkbox" name="cycles[]" value="7Years"
                                                      {if in_array("7Years", $promo_set['cycles'])}checked{/if}>
                    7 {$lang['Years']}
                </label>
                <label class="checkbox-inline"><input type="checkbox" name="cycles[]" value="8Years"
                                                      {if in_array("8Years", $promo_set['cycles'])}checked{/if}>
                    8 {$lang['Years']}
                </label>
                <label class="checkbox-inline"><input type="checkbox" name="cycles[]" value="9Years"
                                                      {if in_array("9Years", $promo_set['cycles'])}checked{/if}>
                    9 {$lang['Years']}
                </label>
                <label class="checkbox-inline"><input type="checkbox" name="cycles[]" value="10Years"
                                                      {if in_array("10Years", $promo_set['cycles'])}checked{/if}>
                    10 {$lang['Years']}
                </label>
            </td>
        </tr>
        <tr>
            <td class="fieldlabel">
                {$lang['Start Date']}
            </td>
            <td class="fieldarea">
                <div class="form-group date-picker-prepend-icon">
                    <label for="inputStartDate" class="field-icon">
                        <i class="fal fa-calendar-alt"></i>
                    </label>
                    <input id="inputStartDate" type="text" name="start_date" value="{$promo_set['start_date']}"
                           class="form-control date-picker-single future">
                    ({$lang['Leave blank for none']})
                </div>
            </td>
        </tr>
        <tr>
            <td class="fieldlabel">
                {$lang['Expiry Date']}
            </td>
            <td class="fieldarea">
                <div class="form-group date-picker-prepend-icon">
                    <label for="inputExpirationDate" class="field-icon">
                        <i class="fal fa-calendar-alt"></i>
                    </label>
                    <input id="inputExpirationDate" type="text" name="expiration_date"
                           value="{$promo_set['expiration_date']}"
                           class="form-control date-picker-single future">
                    ({$lang['Leave blank for none']})
                </div>
            </td>
        </tr>
        <tr>
            <td class="fieldlabel">{$lang['Max Uses']}</td>
            <td class="fieldarea"><input type="text" name="max_uses"
                                         class="form-control input-100 input-inline" value="{$promo_set['max_uses']}">
                ({$lang['Enter 0 to allow unlimited uses']})
            </td>
        </tr>
        <tr>
            <td class="fieldlabel">{$lang['Lifetime Promotion']}</td>
            <td class="fieldarea"><label class="checkbox-inline"><input type="checkbox" name="lifetime_promo"
                                                                        value="on"
                                                                        {if $promo_set['lifetime_promo'] eq '1'}checked{/if}>
                    {$lang['Discounted pricing is applied even on upgrade and downgrade orders in the future regardless of settings like max uses, expiry, etc;']}
                </label></td>
        </tr>
        <tr>
            <td class="fieldlabel">{$lang['Apply Once']}</td>
            <td class="fieldarea"><label class="checkbox-inline"><input type="checkbox" name="apply_once" value="on"
                                                                        {if $promo_set['apply_once'] eq '1'}checked{/if}>
                    {$lang['Apply only once per order (even if multiple items qualify)']}</label></td>
        </tr>
        <tr>
            <td class="fieldlabel">{$lang['New Signups']}</td>
            <td class="fieldarea"><label class="checkbox-inline"><input type="checkbox" name="new_signups" value="on"
                                                                        {if $promo_set['new_signups'] eq '1'}checked{/if}>
                    {$lang['Apply to new signups only (must have no previous active orders)']}</label></td>
        </tr>
        <tr>
            <td class="fieldlabel">{$lang['Apply Once / Client']}</td>
            <td class="fieldarea"><label class="checkbox-inline"><input type="checkbox" name="once_per_client"
                                                                        value="on"
                                                                        {if $promo_set['once_per_client'] eq '1'}checked{/if}>
                    {$lang['Apply only once per client globally (ie. only one order allowed per promo)']}</label></td>
        </tr>
        <tr>
            <td class="fieldlabel">{$lang['Existing Client']}</td>
            <td class="fieldarea"><label class="checkbox-inline"><input type="checkbox" name="existing_client"
                                                                        value="on"
                                                                        {if $promo_set['existing_client'] eq '1'}checked{/if}>
                    {$lang['Apply to existing clients only (must have an active order to qualify)']}</label></td>
        </tr>
        <tr>
            <td class="fieldlabel">{$lang['Upgrades/Downgrades']}</td>
            <td class="fieldarea"><label class="checkbox-inline"><input type="checkbox" name="upgrades" value="on"
                                                                        {if $promo_set['upgrades'] eq '1'}checked{/if}>
                    {$lang['Enable for product upgrades']}</label>

                <div id="upgradeoptions">
                    <table class="form" width="100%" border="0" cellspacing="2" cellpadding="3">
                        <tbody>
                        <tr>
                            <td colspan="2" class="fieldarea"><b>{$lang['Upgrade Promotion Instructions']}</b>
                                <br>{$lang['For all upgrade promotion codes, the "Applies To" field defines the products that the promotion applies to']}
                                <br>{$lang['For product upgrades/downgrades, "Requires" can also be used to restrict the products being upgraded from']}
                                <br>{$lang['And for configurable option upgrades/downgrades, you can select the specific options to apply the discount to below']}
                                <br>{$lang['If you set a discount value & enable recurring above, then the upgrade promo will also give a recurring discount to the parent product']}
                            </td>
                        </tr>
                        <tr>
                            <td class="fieldlabel">{$lang['Upgrade Type']}</td>
                            <td class="fieldarea"><input type="radio" name="upgrade_type" value="product"
                                                         {if $promo_set['upgrade_type'] eq 'product'}checked{/if}>
                                Products/Services <input type="radio" name="upgrade_type" value="configoptions"
                                                         {if $promo_set['upgrade_type'] eq 'configoptions'}checked{/if}>
                                Configurable Options
                            </td>
                        </tr>
                        <tr>
                            <td class="fieldlabel">{$lang['Upgrade Discount']}</td>
                            <td class="fieldarea"><input type="text" name="upgrade_value" size="10"
                                                         value="{$promo_set['upgrade_value']}">
                                <select name="upgrade_discount_type">
                                    <option value="Percentage"
                                            {if $promo_set['upgrade_discount_type'] eq 'Percentage'}selected{/if}>
                                        Percentage
                                    </option>
                                    <option value="Fixed Amount"
                                            {if $promo_set['upgrade_discount_type'] eq 'Fixed Amount'}selected{/if}>
                                        Fixed Amount
                                    </option>
                                </select></td>
                        </tr>
                        <tr>
                            <td class="fieldlabel">{$lang['Config Options Upgrades']}</td>
                            <td class="fieldarea">
                                <select name="config_option_upgrades[]" size="8" style="width:90%" multiple="">
                                    {foreach $config_options as $option}
                                        <option value="{$option['id']}"
                                                {if in_array($option['id'], $promo_set['config_option_upgrades'])}selected{/if}>
                                            {$option['group_name']} - {$option['name']}</option>
                                    {/foreach}
                                </select><br>{$lang['The options selected above are the ones the discount is applied to when Upgrade Type is set to Configurable Options']}
                            </td>
                        </tr>
                        </tbody>
                    </table>
                </div>

            </td>
        </tr>
        <tr>
            <td class="fieldlabel">{$lang['Notes']}</td>
            <td class="fieldarea"><textarea name="notes" rows="4" class="form-control">{$promo_set['notes']}</textarea>
            </td>
        </tr>
        </tbody>
    </table>

    <div class="btn-container">
        <button type="submit" name="submit" value="edit_set" class="btn btn-primary">{$lang['Save Changes']}</button>
        <input type="button" value="Cancel Changes" class="btn btn-default"
               onclick="window.location='addonmodules.php?module=puq_customization&extension=promo_code_api&action=promo_sets'">
        <button type="submit" name="submit" value="delete_set" class="btn btn-danger"
                onclick="return confirm('{$lang['Are you sure you want to delete?']}')">{$lang['Delete Set']}
        </button>
    </div>

</form>